.nolist
include \masm32\include\masm32rt.inc
; include \masm32\MasmBasic\MasmBasic.inc
.686
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 1000000-1

.data
; Src	db "x", 0	; strings with len<2 let szRev crash
    padd db 0,0,0
Src	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos..", 0

.code
start:
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString
	counter_end
	print str$(eax), 9, "cycles for RevString", 13, 10
	print offset Src, 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString2
	counter_end
	print str$(eax), 9, "cycles for RevString2", 13, 10
	print offset Src, 13, 10

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevStr
	counter_end
	print str$(eax), 9, "cycles for RevStr", 13, 10
	print offset Src, 13, 10
if 1	; chokes for strings with len<2
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		push offset Src
		call szRev1
	counter_end
	print str$(eax), 9, "cycles for szRev", 13, 10
	print offset Src, 13, 10
endif

	print chr$(13, 10, "Sizes:", 13, 10)
	mov eax, RevString_e
	sub eax, RevString_s
	print str$(eax), 9, "RevString", 13, 10
	mov eax, RevString2_e
	sub eax, RevString2_s
	print str$(eax), 9, "RevString2", 13, 10
	mov eax, RevStr_e
	sub eax, RevStr_s
	print str$(eax), 9, "RevStr", 13, 10
	mov eax, szRev_e
	sub eax, szRev_s
	print str$(eax), 9, "szRev", 13, 10
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

align 16
RevString_s:
RevString proc
	push esi
	push edi
	mov esi, [esp+4+8]
	lea edi, [esi+len(esi)]	; you must know the end of the string
	shr eax, 3				; len div 8 - we use dwords and meet in the middle
	je @F
	.Repeat
		sub edi, 4
		mov ecx, [esi]
		mov edx, [edi]
		bswap ecx
		bswap edx
		mov [edi], ecx
		mov [esi], edx
		add esi, 4
		dec eax
	.Until Zero?
@@:	dec edi
	cmp edi, esi
	jbe @F
	movzx eax, byte ptr [esi]
	movzx edx, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	jmp @B
@@:	pop edi
	pop esi
	ret 4
RevString endp
RevString_e:

align 16
RevString2_s:
RevString2 proc
	push esi
	push edi
	mov esi, [esp+4+8]
	if 1
		invoke StrLen, esi
		lea edi, [esi+eax-4]		; you must know the end of the string
	else
		lea edi, [esi+len(esi)-4]	; you must know the end of the string - but szLen is slow
	endif
	cmp eax, 4
	jb @F
	.Repeat
	if 1	; 64 bytes
		mov edx, [edi]
		lodsd
		bswap edx
		mov [esi-4], edx
		bswap eax
		mov [edi], eax
		sub edi, 4
	else	; 67 bytes
		mov edx, [edi]
		mov eax, [esi]
		bswap eax
		bswap edx
		mov [edi], eax
		mov [esi], edx
		sub edi, 4
		add esi, 4
	endif
	.Until edi<esi
@@:	add edi, 4
@@:	dec edi
	cmp edi, esi
	jbe @F
	mov al, byte ptr [esi]
	mov dl, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	jmp @B
@@:	pop edi
	pop esi
	ret 4
RevString2 endp
RevString2_e:

align 16
RevStr_s:
RevStr  proc
        push    edi
        push    esi
        mov     edi,[esp+4+8]
        mov     esi,edi
        add     edi,len(edi)                ; you must know the end of the string
        shr     eax,3                       ; len div 8 - we use dwords and meet in the middle
        jz      RevSt2

RevSt0: sub     edi,4
        mov     ecx,[esi]
        mov     edx,[edi]
        bswap   ecx
        bswap   edx
        mov     [edi],ecx
        mov     [esi],edx
        dec     eax
        lea     esi,[esi+4]
        jnz     RevSt0

        jmp short RevSt2

RevSt1: movzx   edx,byte ptr [edi]
        movzx   eax,byte ptr [esi]
        mov     [esi],dl
        mov     [edi],al
        inc     esi

RevSt2: dec     edi
        cmp     edi,esi
        ja      RevSt1

        pop     esi
        pop     edi
        ret     4
RevStr  endp
RevStr_e:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
szRev_s:
szRev1 proc src:DWORD,dst:DWORD

  ; ------------------------------------
  ; this version will reverses a string
  ; in a single memory buffer so it can
  ; accept the same address as both src
  ; and dst.
  ; ------------------------------------

    push esi
    push edi

    mov esi, [esp+4][8]     ; src
    mov edi, [esp+8][8]     ; dst
    xor eax, eax            ; use EAX as a counter

  ; ---------------------------------------
  ; first loop gets the buffer length and
  ; copies the first buffer into the second
  ; ---------------------------------------
 ;   @@:
 ;     movzx edx, BYTE PTR [esi+eax]       ; copy source to dest
 ;     ;; mov [edi+eax], dl
 ;     add eax, 1                          ; get the length in EAX
 ;     test edx, edx
 ;     jne @B

    invoke StrLen,esi

    mov esi, [esp+8][8]                 ; put dest address in ESI
    mov edi, esi                        ; same in EDI
    ; sub eax, 1                          ; correct for exit from 1st loop <<<<<<<<<<< little bug
    lea edi, [edi+eax-1]                ; end address in edi
    shr eax, 1                          ; int divide length by 2
    neg eax                             ; invert sign
    sub esi, eax                        ; sub half len from ESI

  ; ------------------------------------------
  ; second loop swaps end pairs of bytes until
  ; it reaches the middle of the buffer
  ; ------------------------------------------
  @@:
    movzx ecx, BYTE PTR [esi+eax]       ; load end pairs
    movzx edx, BYTE PTR [edi]
    mov [esi+eax], dl                   ; swap end pairs
    mov [edi], cl
    sub edi, 1
    add eax, 1
    jnz @B                              ; exit on half length

    ;; mov eax, dst                     ; return destination address

    pop edi
    pop esi

    ret 8

szRev1 endp
szRev_e:
end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]